// Emacs style mode select   -*- C++ -*-
//-----------------------------------------------------------------------------
//
// Copyright (C) 1993-1996 by id Software, Inc.
// Copyright (C) 1998-2000 by DooM Legacy Team.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//-----------------------------------------------------------------------------
/// \file
/// \brief SRB2 strings, by language.

#ifndef __DSTRINGS__
#define __DSTRINGS__

// Misc. other strings.
#define SAVEGAMENAME "srb2sav"

extern char savegamename[256];

//
// File locations,
//  relative to current position.
// Path names are OS-sensitive.
//
#define DEVMAPS "devmaps"
#define DEVDATA "devdata"

#define NUM_QUITMESSAGES 22

//
// Array holding all strings used in SRB2.
// Can be replaced with strings in other languages in future
// external or internal file support.
//
typedef enum
{
	D_DEVSTR,
	D_CDROM,
	PRESSKEY,
	PRESSYN,
	LOADNET,
	QLOADNET,
	QSAVESPOT,
	SAVEDEAD,
	QSPROMPT,
	QLPROMPT,
	NEWGAME,
	ULTIMATE,
	MSGOFF,
	MSGON,
	NETEND,
	ENDGAME,
	DOSY,

	NOROOMNETBUF,
	UNKNOWNNETCMD,
	JOINREQUEST,
	NOSAVEGAMEMEM,
	LOADSAVEGAME,
	MAPISNOW,
	ZONE,
	CANNOTLOADLEVEL,
	CANNOTDELETE,
	ESCABORT,
	SEARCHSERV,
	CONTACTSERV,
	CONNECTINGTO,
	NETGAMETYPE,
	NETVERSION,
	FOUND,
	CHECKINGFILES,
	NETSYNCABORT,
	BANLIST,
	BANLIST2,
	BANLIST3,
	BANREASON,
	BANNONE,
	CANNOTSAVEBANLIST,
	CANNOTLOADBANLIST,
	CONNECTHELP,
	NOCONNECTINGAME,
	NOSERVERIDENTIFY,
	NONETWORKDRIVER,
	PLAYERNUM,
	SERVERPLAYERNUM,
	NOPLAYERNAMED,
	NODESCMDTXT,
	NODESCMDTXT2,
	NODESCMDTXT3,
	NODESCMDADMIN,
	NODESCMDSPEC,
	BANHELP,
	TOOMANYBANS,
	YOUARENOTTHESERVER,
	KICKHELP,
	SERVERREMOTESHUTDOWN,
	ILLEGALKICKCMD,
	KICKEDPLAYERNAME,
	KICKEDGOAWAY,
	KICKEDCONSFAIL,
#ifdef NEWPING
	KICKEDPINGTOOHIGH,
#endif
	LEFTGAME_TIMEOUT,
	LEFTGAME,
	KICKEDBANNED,
	CUSTOMKICKMSG,
	CUSTOMBANMSG,
	ILLEGALADDPLRCMD,
	PLAYERINGAME,
	PLAYERADDRESS,
	STARTINGSERVER,
	JOINACCEPTED,
	CONSFAILRESTORE,
	CONSIS_DUMP1,
	CONSIS_DUMP2,
	CONSIS_DUMP3,

	I_STARTUPKEYBOARD,
	I_STARTUPMOUSE,
	I_STARTUPTIMER,
	I_STARTUPGRAPHICS,
	SETVBUF_FAIL,
	PLAYINGDEMO,

	SET_EXTRATICS,
	SET_BANDWIDTH,
	DEBUG_OUTPUT,
	NODEBUG_OUTPUT,
	CMD_PING,

	RENAMED_TO,
	ILLEGALNAMECMD,
	ILLEGALCOLORCMD,
	ORDERPIZZAHELP,
	ORDEREDPIZZA,
	RTELEPORTHELP,
	INVALIDLOCATION,
	TELEPORTINGBY,
	XNOTSPECIFIED,
	YNOTSPECIFIED,
	TELEPORTINGTO,
	PLAYDEMO_HELP,
	PLAYBACK_DEMO,
	TIMEDEMO_HELP,
	TIMING_DEMO,
	STOPPED_DEMO,
	MAPCHANGE_DEBUG,
	MAPCHANGE_HELP,
	SERVER_CHANGELEVEL,
	LEVEL_NOTFOUND,
	NOLVLCHANGE,
	INVALID_LEVELNAME,
	NOGTCHANGE,
	GTNOTSUPPORTED,
	SPNOTSUPPORTED,
	ILLEGALMAPCMD,
	ILLEGALPAUSECMD,
	GAME_PAUSED,
	GAME_UNPAUSED,
	ILLEGALCLRSCRCMD,
	SCORESRESET,
	CHANGETEAM_HELP1,
	CHANGETEAM_HELP2,
	NOMTF,
	NOTMCTF,
	CHANGETEAM2_HELP1,
	CHANGETEAM2_HELP2,
	SERVER_CHANGETEAM,
	SERVERCHANGETEAM_HELP1,
	SERVERCHANGETEAM_HELP2,
	SERVERCHANGETEAM_HELP3,
	TEAMS_SCRAMBLED,
	PLAYER_ONTEAM,
	NO_TAGCHANGE,
	ILLEGALTEAMCHANGECMD,
	SENTILLEGALTEAMCHANGE,
	NOW_IT,
	NO_LONGER_IT,
	REDTEAM_SWITCH,
	BLUETEAM_SWITCH,
	SPECTATOR_SWITCH,
	INGAME_SWITCH,
	AUTOBALANCE_SWITCH,
	SCRAMBLE_SWITCH,
	SERVER_CHANGEPASSWORD,
	PASSWORD_HELP,
	LOGIN_HELP,
	SENDING_LOGIN,
	PASSED_AUTH,
	PASSWORD_FAILED,
	SERVER_VERIFY,
	VERIFY_HELP,
	ILLEGALVERIFYCMD,
	PASSWORD_CORRECT,
	MOTD_HELP,
	ILLEGALMOTDCMD,
	MOTD_SET,
	RUNSOC_HELP,
	ILLEGALRUNSOCCMD,
	SOC_NOTFOUND,
	ILLEGALCONSCMD,
	ADDFILE_HELP,
	NEED_NO_LEVEL,
	ILLEGALADDFILECMD,
	ILLEGALDELFILECMD,
	CHECKSUM_MISMATCH,
	WAD_NOTFOUND,
	NUMWADSLOADED,
	LISTWAD1,
	LISTWAD2,
	LISTIWAD,
	VERSIONCMD,
	MODDETAILSCMD,
	GAMETYPECMD,
	JUMPTOAXIS_HELP,
	POINTLIMIT_MESSAGE,
	A_TEAM,
	SOMEONE,
	POINTLIMIT_DISABLED,
	NUMLAPS_MESSAGE,
	TIMELIMIT_MESSAGE,
	TIMELIMIT_DISABLED,
	GAMETYPE_CHANGED,
	HIDETIME_ERROR,
	SHOWMAP1,
	SHOWMAP2,
	ILLEGALEXITLVLCMD,
	DISPLAYPLAYERCMD,
	CHANGESKY_HELP,
	SKYNUM_HELP,
	SKYNUM_PREVIEW,
	TUNES_HELP,
	TUNES_CURRENT,
	TUNES_VALIDSLOTS,
	GAMEMODIFIEDHELP1,
	GAMEMODIFIEDHELP2,
	GAMEMODIFIEDHELP3,
	FORCESKIN_HELP,
	NO_NAME_CHANGE,
	CHAT_MUTED,
	CHAT_NOT_MUTED,
	SHOWSCORESCMD,
	SHOWSCORES_POINTLIMIT,
	SHOWTIMECMD,

	CANNOT_CHANGE_CHEATS,
	CHEATS_REQUIRED,
	CHEATS_ACTIVATE,
	CHEATS_ACTIVATED,

	DOWNLOADING_DONE,

	THING_NOTEXIST,
	MOD_BY,
	CHAR_OUTOFRANGE,
	LEVEL_OUTOFRANGE,
	CUTSCENE_OUTOFRANGE,
	UNLOCKABLE_OUTOFRANGE,
	FRAME_NOTEXIST,
	SOUND_NOTEXIST,
	HUDITEM_OUTOFRANGE,
	EMBLEM_OUTOFRANGE,
	WRONG_VERSION_WARNING,
	SUPPORTED_VERSION,
	UNKNOWN_WORD,
	MISSING_ARGUMENT,
	MISSING_WORD,
	WARNING_IN_SOC_LUMP,
	UNLOADING_SOC_EDITS,

	GAMMALVL0,
	GAMMALVL1,
	GAMMALVL2,
	GAMMALVL3,
	GAMMALVL4,
	EMPTYSTRING,

	GGSAVED,
	HUSTR_MSGU,

	STSTR_CLEV,
	ROUND_END,

	PDEAD_ETC,
	TELEPORT_HELP,
	UNABLE_TELEPORT,
	NETGAME_TELEPORT,
	INVALID_LOCATION,
	NETGAME_DEMO,
	CTFCMD_ONLY,
	ALREADYONTEAM,
	NOTEAMCHANGE,
	SERVERONLY,
	GAMEMODIFIED,
	FILE_NOT_FOUND,
	CLIENT_NEEDFILE,
	NEED_DEVMODE,
	NOTEARNED,
	MUSTBEINLEVEL,
	CANTUSESINGLEPLAYER,
	CANTUSEMULTIPLAYER,
	NETGAMEONLY,
	SINGLEPLAYERONLY,
	SERVERPAUSE,
	PAUSEINFO,
	CANTREADFILE,
	OBJPLACEINFO,

	POWERUPNOTARGET,

	REDFLAG_RETURNED,
	REDFLAG_PICKUP,
	BLUEFLAG_RETURNED,
	BLUEFLAG_PICKUP,
	PLAYERTOSSFLAG,
	PLAYERDROPFLAG,

	PDEAD_MATCHCRUSHED,
	PDEAD_SUICIDE,
	PDEAD_DIED,
	P_HITVERB,
	P_KILLEDVERB,
	P_REFLECT,
	PHURT_GOTNUKED,
	PHURT_GOTBURNED,
	PHURT_FIRETRAIL,
	PHURT_B,
	PHURT_A,
	PHURT_E,
	PHURT_R,
	PHURT_S,
	PHURT_G,
	PHURT_RING,
	PHURT_MATCHDEFAULT,
	PDEAD_DROWNED,
	PDEAD_CRUSHED,
	PHURT_BCRAWLA,
	PHURT_RCRAWLA,
	PHURT_JETG,
	PHURT_JETB,
	PHURT_CCRAWLA,
	PHURT_BOSS1,
	PHURT_BOSS2,
	PDEAD_PIT,
	PDEAD_GOOP,
	PDEAD_FIRE,
	PDEAD_ELEC,
	PDEAD_SPIK,
	PDEAD_SPAC,
	PHURT_HIT,
	WORLD_OF_PAIN,
	PLAYERGAMEOVER,
	PLAYERLIVESREMAINING,
	PLAYERISIT,

	CYCLE_DETECT,

	FINISHEDFINALLAP,
	STARTEDLAP,

	FINISHEDLEVEL,
	TOOHIGH_4095,
	TOOHIGH_2047,
	OUT_OF_TIME,

	INTRO01TEXT,
	INTRO02TEXT,
	INTRO03TEXT,
	INTRO04TEXT,
	INTRO05TEXT,
	INTRO06TEXT,
	INTRO07TEXT,
	INTRO08TEXT,
	INTRO09TEXT,
	INTRO10TEXT,
	INTRO11TEXT,
	INTRO12TEXT,
	INTRO13TEXT,
	INTRO14TEXT,
	INTRO15TEXT,
	INTRO16TEXT,

	QUITMSG,
	QUITMSG1,
	QUITMSG2,
	QUITMSG3,
	QUITMSG4,
	QUITMSG5,
	QUITMSG6,
	QUITMSG7,

	QUIT2MSG,
	QUIT2MSG1,
	QUIT2MSG2,
	QUIT2MSG3,
	QUIT2MSG4,
	QUIT2MSG5,
	QUIT2MSG6,

	QUIT3MSG,
	QUIT3MSG1,
	QUIT3MSG2,
	QUIT3MSG3,
	QUIT3MSG4,
	QUIT3MSG5,
	QUIT3MSG6,

	MODIFIED,
	COMERCIAL,

	M_LOAD,
	Z_INIT,
	W_INIT,
	M_INIT,
	R_INIT,
	P_INIT,
	I_INIT,
	D_CHECKNET,
	S_SETSOUND,
	HU_INIT,
	ST_INIT,

	SRB2SRB,
	SRB2WAD,
	SONICPLR,
	TAILSPLR,
	KNUXPLR,
	MUSICWAD,

	CDROM_SAVEI,
	NORM_SAVEI,

	SPECIALDEHACKED,

	SRB2TITLE = SPECIALDEHACKED,

	NUMTEXT
} text_enum;

extern const char *text[];

#endif
